#version 330 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out vec3 theNormal;
out vec2 fragmentUV;
out vec3 fragmentPos;
out vec2 viewportPos;
out vec2 prevViewportPos;

uniform mat4 modelViewProjMat;
uniform mat4 prevModelMat;
uniform mat4 viewProjMat;
uniform mat4 modelMat;
uniform mat4 gModelMat; // geometry model matrix
uniform mat3 normalMatrix;

void main()
{
	fragmentUV = uv;
	gl_Position = modelViewProjMat * vec4(position, 1);
	viewportPos = gl_Position.xy;
	prevViewportPos = (viewProjMat * prevModelMat * gModelMat * vec4(position, 1)).xy;
	theNormal = normalMatrix * normal;
	fragmentPos = (modelMat * vec4(position, 1)).xyz;
}